#! /usr/bin/env python
# -*- coding: UTF-8 -*-/**-
#  Calc.py =computational objects servocine
from Tkinter import *
from tkSnack import *
import math
import Newton
# you may change theses parameters  depending on the CPU speed and the audio card
TSAMPLE=100 #length of a sound sample from the TX
TSHOW=127    # renew the ttx channel show every msec
FREQ=44100 # sampling rate of the sound card
#
DEGR= math.pi/180 # conversion from degree to radian
DEBUG=False

def debug( x):
        if DEBUG:            print x
class TX:
    # fixed PPM parameters of your transmitter + the whole configuration of servo and linkages
   def __init__(self):
       self.normalPulse = 0.0015 # or neutral pulse width
       self.maxPulse= 0.00055   # displacement 100% as reported by the transmitter
       self.triggerlevel=.8            # this is the level where the signal switches
       # normal pulse Futaba  1.52 msec  Uni=1.5 +/- 0.55 MPX=1.6 +/- 0.55
       self.linkage= {}  #  servo linkage indexed by channel number (from 1 to ...12)
       self.modelfilename=""
       self.PCM=False # special for PCM detection of a servo pulse
       self.PCMch=1      # channel iof the PCM receiver which is connected





class TXsignal :
    # get and analyse PPM frame
    def __init__(self, txparam):
        #snd is a sound file, with several PPM frames, to be  synchronized and cropped
        self.snd = Sound(frequency=FREQ)
        self.ppm=[] # item[0]=channel"  item[1 ]=longueur item[2]=pulse length in sec item[3]=transmitter signal in percentage
        self.txparam=txparam

    def record(self):
        #self.snd.flush()
        self.snd.record()
        #print "Start recording"""
    def stopRecord(self):
        self.snd.stop()
        #print "Stop recording"
        #print self.snd.info()
    def val(self, v, z):
        #returns -1 if signal is low and +1  if the signal is high
        if v < z:
            return -1
        else:
            return +1
    def sync(self):
        if self.snd.length()<1000:  # how many samples
            #print "Error snd to short"
            return
        x=1
        chanel=0 # tx chanel measured
        startPulse=0.0   # begin of a pulse, positive or negative
        startPulseS=0.0  #start of a signal pulse (from the ground, defined by the long start pulse
        xstop= int(FREQ*0.0003*0.9) #stop pulse = 0.3 msec between chanels
        xstart=int(FREQ*0.003)# start pulse > 3 msec
        xsync=-1.0
        self.ppm=[]
        # search the pulses
        min=float(self.snd.min())
        max=float(self.snd.max())
        moy=(min+max)/2
        z= int(moy +self.txparam.triggerlevel*max)
        valuep=self.snd.sample(x) # former value of the signal
        while x < self.snd.length()-1 :
            x = x+1
            value=self.snd.sample(x) 
            if value<z and valuep< z:
                valuep=value
                continue
            if value>z and valuep>z:
                valuep=value
                continue          
            #pulse found, interpol the z crossing value of x if 'up' from ground level
            fvalue=float(value)
            fvaluep=float(valuep)
            valuep=value
            xvalue= x +(fvalue-z )/(fvaluep-fvalue) # interpolated x crossing the 0
            long=xvalue-startPulse # pulse length
            startPulse=xvalue
            if long > xstart and xsync >0:
                #second start pulse
                break
            if long > xstart:
                #start pulse found  found -> sync for oscilloscope

                xsync=xvalue
                startPulseS=xvalue
                xmod=self.val(value, z) # identifies the modulation of the signal (sign of signal pulse) 
                #print "Sync Pulse"+str(x) +" sign="+str(xmod)
                continue 
            if  xsync >0:
                if xmod==self.val(value, z): 
                    #signal pulse 
                    long=xvalue-startPulseS # pulse length
                    startPulseS=xvalue
                    chanel=chanel+1
                    w=long /FREQ# pulse length in sec
                    p=100*(long/FREQ - self.txparam.normalPulse)/self.txparam.maxPulse # transmitter signal in percentage
                    self.ppm.append((chanel, long, w, p))
                    #print "Chanel %3.0i  signal %1.4f   percent=%4.0f"% (chanel, w, p)
        self.snd.crop(start=int(xsync-10),  end=x)
    def syncPCM(self):
        if self.snd.length()<1000:  # how many samples
            #print "Error snd to short"
            return
        x=1
        #chanel=0 # tx chanel measured
        startPulse=0.0   # begin of a pulse, positive or negative
        startPulseS=0.0  #start of a signal pulse (from the ground, defined by the long start pulse
        xmaxpulse=int(FREQ*0.0025)# max length servo  pulse < 2.5 msec
        xsync=-1.0
        self.ppm=[]
        # search the pulses
        min=float(self.snd.min())
        max=float(self.snd.max())
        moy=(min+max)/2
        z= int(moy +self.txparam.triggerlevel*max)
        valuep=self.snd.sample(x) # former value of the signal
        first=0
        while x < self.snd.length()-1 :
            x = x+1
            value=self.snd.sample(x) 
            if value<z and valuep< z:
                valuep=value
                continue
            if value>z and valuep>z:
                valuep=value
                continue          
            #pulse found, interpol the z crossing value of x if 'up' from ground level
            fvalue=float(value)
            fvaluep=float(valuep)
            valuep=value
            xvalue= x +(fvalue-z )/(fvaluep-fvalue) # interpolated x crossing the 0
            long=xvalue-startPulse # pulse length
            startPulse=xvalue
            first=first+1
            if first==1: continue
            if long < xmaxpulse:
                #servo pulse found  found 
                w=long /FREQ# pulse length in sec
                p=100*(long/FREQ - self.txparam.normalPulse)/self.txparam.maxPulse # transmitter signal in percentage
                self.ppm.append((self.txparam.PCMch, long, w, p)) # only channel 1
                print "signal %1.4f   percent=%4.0f"% ( w, p)
                break
        self.snd.crop(start=int(xsync-10),  end=x)
class servo:
    # basis class for a control: the servo and the control surface
    # to be herited by a servo_xxx class which provides the details of the linkage between servo and cpontrol surface
    # each xxx has to define 
    #    the geometrical parameters of the linkage
    #    a function who computes a length of control rod or cable 
    degR= math.pi/180 # conversion from degree to radian
    def __init__(self, channel):
        self.name="servo" #class name
        #servo PPM parameters, angle are in radians
        self.channel=channel   # channel number 1 to ...12
        self.descr=" test "   #short description < 10 car
        # generally like TX
        self.normalPulse=.0015  # pulse width at the neutral position
        self.maxPulse=0.00055    # sup. pulse width for the normal 100% deflection
        self.servodev=35  *DEGR               # servo deflection for a pulse 100%
        self.servoDirection=1 # +1 -> + 100% is toward the control surface    -1 if the other direction
        self.rp=15.0  # servo arm radius
        self.dp=3.0 # servo arm shift
        self.p=-1 #  1 if  servo arm is up / -1 if down
        #horn parameters
        self.rg=20.0 # horn radius
        self.dg=4.0  # horn shift
        self.ctrl_c =40.0 # control surface  chord
        self.ctrl_a=5.0 *DEGR    # neutral position of control surface
        self.g=1   #  1 if  horn  is up / -1 if down
        #computed value (should be a "return" list)
        self.length = -1000 # length of the control rod or other length that has to be constant
        #last position of the servo
        self.npa=0 #last servo angle
        self.xpn=0  # x, reference servo axis
        self.ypn=0
        # default distance servo-horn (needed for the canvas)
        self.dh=100
        self.dv=0        
        #last position of the horn
        self.nga=0 #last  horn angle
        self.xgn=0  # x ,reference horn axis
        self.ygn=0
        self.np=0 #last horn angle
        #last position control surface
        self.ctrla=0
        self.xa =0
        self.ya=0
    def getLength(self, xservo, yservo, xhorn, yhorn):
        #this method should be overridden for each linkage
        #computes a distance between one known position of the servo and one possiblle position of the horn
        return 0
    
    def init(self):
        #compute positions at centered sticks
        # to be called after every change of a dimension 
        #_____________neutral position for servo and horn____________________________---
        self.np = self.p*math.asin(self.dp/self.rp)  # np= initial angle servo arm (neutral position)  dp=rp* sin(np)
        # xp,yp = position hole of  servo arm, reference =servo axis
        self.xp=self.p*self.rp*math.sin(self.np)  
        self.yp=self.p*self.rp*math.cos(self.np)
        # xg,yg = position hole/horn, reference = control surface  hinge
        ng= self.g*math.asin(self.dg/self.rg) #angle control horn
        self.delta=math.pi/2 -ng+self.ctrl_a # constant  pi/2 -ng +a =delta
        self.xg=self.g*self.rg*math.sin(ng)
        self.yg=self.g*self.rg*math.cos(ng)
        #position control surface
        self.xa =self.ctrl_c*math.cos(self.ctrl_a)
        self.ya =-self.ctrl_c*math.sin(self.ctrl_a)
        debug ("Init Servo=%3.1f°" %( self.npa/DEGR , )) 
        # length of the linkage
        self.length=self.getLength(self.xp, self.yp, self.xg, self.yg)
        
        self.nga=ng
        debug("Init Servo=%3.1f Horn angle %4.1f° Control rod =%5.1f mm"%(self.np /DEGR,self.nga/DEGR,  self.length ))
        self.scale=1.0
        
    def getCtrl(self, signal):
        # signal = PPM pulse width, in sec
        #computes instance variables with the whole  position
        #    the angular position of the control surface and xy 
        #     angle and x,y for the servo 
        #     angle andx,y for the horn
        #_______________ New position  servo___________________
        z= self.servoDirection*self.servodev * (signal-self.normalPulse)/self.maxPulse #servo deflection
        self.npa =self.np +z    # new servo angle
        debug ("Signal=%3.2fmsec Servo=%3.1f° " %(signal*1000 , self.npa/DEGR ), ) 
        # xp,yp = position clevis / servo
        self.xpn=self.p*self.rp*math.sin(self.npa)  
        self.ypn=self.p*self.rp*math.cos(self.npa)
        # control rod length  for a horn angle = a
        def terr(a):
            #returns the "error" in the length, to be solved by Newton iterations
            # a is the angle of the control horn 
            self.xgn=self.g*self.rg*math.sin(a) #new position horn (reference hinge)
            self.ygn=self.g*self.rg*math.cos(a)
            return self.getLength(self.xpn, self.ypn,self.xgn, self.ygn )  -self.length
        # find the angle for the horn, such that the lenght is the original length
        self.nga = Newton.solver(terr, self.nga) # iterations to find horn angle 
        # may throw an exception if no solution
        #---------------------has to throw an error
        
        
        #computes position xy of the control surface
        debug("Horn angle %4.1f°  Control rod calc=%5.1f mm"%(self.nga/DEGR , terr(self.nga), ))
        self.ctrla=self.nga+self.delta-math.pi/2 #control surface angle
        self.xan =self.ctrl_c*math.cos(self.ctrla)
        self.yan =-self.ctrl_c*math.sin(self.ctrla)
        self.ctrld=math.sqrt((self.xan-self.xa)**2 +(self.yan-self.ya)**2) #control surface deflection
        if self.ctrla < self.ctrl_a :  
            self.ctrld=-self.ctrld
        
    def getCanLinkage(self, can, colour): 
        # to be overridden for each linkage 
        # supplementary canvas elements
        pass
    def getCan(self, can, colour):   
        #update a canvas with the schema  of servo , horn and control surface
        # canvas dimension
        config= can.config()
        w=float(config['width'][4])  #width of the canvas
        self.h= float(config['height'][4])#height
        #how to scale the graph = c is the onversion factor mm->pixel
        scale_h =(2.0 *self.ctrl_c+self.dv )/self.h 
        scale_w=(self.dh+self.ctrl_c+self.rp+self.rg )/w
        self.scale= min([scale_h, scale_w])  # scale = mm/pixel
        #print scale
        can.delete(ALL)
        # reference= servo axis 
        x0p= 5+self.rp
        y0p = self.h/2
        #conversion from x (mm) to x (pixels)    idem y
        def px(x):              return 5+self.rp/self.scale+(x/self.scale)
        def py(y):              return self.h/2-(y/self.scale)
        def cercle (x, y):
            r=3
            can.create_oval(px(x)-r, py(y)-r, px(x)+r, py(y)+r, fill="red")
        can.create_line(5, y0p, w-5, y0p,  fill="yellow", dash=(4, 4)) # base line
        # servo position neutral stick + signal
        cercle(0, 0)
        can.create_line(px(0), py(0), px(self.xp), py(self.yp),fill=colour,  dash=(2, 4)) #neutral stick
        can.create_line(px(0), py(0), px(self.xpn), py(self.ypn),fill=colour)
        # horn position neutral stick
        cercle(self.dh, self.dv)
        can.create_line(px(self.dh), py(self.dv), px(self.dh+self.xg), py(self.dv+self.yg),fill=colour,  dash=(2, 4)) 
        can.create_line(px(self.dh), py(self.dv), px(self.dh+self.xgn), py(self.dv+self.ygn),fill=colour) 
        #control surface position
        can.create_line(px(self.dh), py(self.dv), px(self.dh+self.xa), py(self.dv+self.ya),fill=colour,  dash=(2, 4)) 
        can.create_line(px(self.dh), py(self.dv), px(self.dh+self.xan), py(self.dv+self.yan),fill=colour) 
        self.getCanLinkage(can, colour) #supplement for this linkage class
        # control surface: angle and  deflection
        tx=  "Angle %3.1f°   %3.0fmm" %( self.ctrla/DEGR , self.ctrld) 
        can.create_text(10, self.h-15, text=tx, anchor=NW,width=300)
class servo_rod(servo):
    
    # linkage geometry with a control rod

    def __init__(self, channel):
        servo.__init__(self, channel)
        self.name="rod"
        #linkage geometry for a rod units =mm
        self.dh  =100.0 #horizontal distance 
        self.dv  =5.0 # vertical distance


    def getLength(self, xservo, yservo, xhorn, yhorn):
        #computes a distance between one known position of the servo and one possiblle position of the horn
        # this for a rod is a real distance
        return math.sqrt((xhorn+self.dh-xservo)**2 + (yhorn +self.dv-yservo)**2)
    def getCanLinkage(self, can, colour): 
        # length of the control rod
        can.create_text(10, 10, text="Rod length=%4.0f mm"%(self.length), anchor=NW,width=300)
        def px(x):              return 5+self.rp/self.scale+(x/self.scale)
        def py(y):              return self.h/2-(y/self.scale)
        can.create_line(px(self.xpn), py(self.ypn), px(self.dh+self.xgn), py(self.dv+self.ygn),fill=colour,  dash=(1, 4))
         
class servo_flexrod(servo):
    # linkage geometry with a pushrod  (gaine en français)

    def __init__(self, channel):
        servo.__init__(self, channel)
        self.name="pushrod"
        #linkage geometry  units =mm
        self.dhp  =60.0 #horizontal distance  from servo hole to airframe
        self.dvp  =-20.0 # vertical distance
        self.dhg  =50.0 #horizontal distance  from airframe to horn
        self.dvg  =12.0 # vertical distance
        self.dv=0 #no meaning , like dh

    def getLength(self, xservo, yservo, xhorn, yhorn):
        #computes a distance between one known position of the servo and one possible position of the horn
        # this for a flexrod is  the distance between the hole (servo arm or horn) to the airframe
        return math.sqrt((self.dhp-xservo)**2+(self.dvp-yservo)**2)+math.sqrt((-self.dhg-xhorn)**2+(self.dvg-yhorn)**2)
    def getCanLinkage(self, can, colour): 
        def px(x):              return 5+self.rp/self.scale+(x/self.scale)
        def py(y):              return self.h/2-(y/self.scale)
        can.create_line(px(self.xpn), py(self.ypn), px(self.dhp), py(self.dvp),fill=colour,  dash=(1, 4)) 
        can.create_line(px(self.dh -self.dhg), py(self.dv+self.dvg), px(self.dh+self.xgn), py(self.dv+self.ygn),fill=colour,  dash=(1, 4))    
#if __name__ == '__main__':
#    test=2
#    if test==1:
#        # test getctrl
#        ctrl=  servo_rod(1)
#        #ctrl=  servo_flexrod(1)
#        ctrl.init()
#        signal = 0.001
#        ctrl.getCtrl(0.0015)
#        ctrl.getCtrl(signal)
#
#        ctrl=  servo_flexrod(1)
#        ctrl.rp=23
#        ctrl.dp=0
#        ctrl.rg=20
#        ctrl.dg=4
#        ctrl.init()
#        signal = 0.00170
#        ctrl.getCtrl(0.0015)
#        ctrl.getCtrl(signal)
#
#        # test getctrl
#        ctrl=  servo_rod(1)
#        #ctrl=  servo_flexrod(1)
#        ctrl.init()
#        signal = 0.001
#        ctrl.getCtrl(0.0015)
#        ctrl.getCtrl(signal)
#
#        ctrl=  servo_flexrod(1)
#        ctrl.rp=23
#        ctrl.dp=0
#        ctrl.rg=20
#        ctrl.dg=4
#        ctrl.init()
#        signal = 0.00170
#        ctrl.getCtrl(0.0015)
#        ctrl.getCtrl(signal)
#    if test==2:
#        from Tkinter import *
#        root = Tk()
#        can = Canvas(root,bg="grey",height=300,width=800)
#        can.pack(side=LEFT)
#        ctrl=  servo_rod(1)
#        ctrl.init()
#        signal=ctrl.normalPulse
#        ctrl.getCtrl(signal)
#        colour="black"
#        ctrl.getCan(can, colour)
#        
#        def getTX(x):    
#            signal=ctrl.normalPulse+float(x)*ctrl.maxPulse
#            ctrl.getCtrl(signal)
#            ctrl.getCan(can, colour)
#    TXsignal = Scale(root, from_=-1, to=+1,  resolution=0.1, label="Tx ", command=getTX)
#    TXsignal.pack(side=LEFT)
#    mainloop()


