#! /usr/bin/env python
# -*- coding: UTF-8 -*-/**-
#  Gui.py =guil objects servocine
from Tkinter import *
import Calc
import tkMessageBox,  copy
import Tkinter
import plot
from tkSnack import *
w=7 # normal width of an Entry 
MODE_ONCE= '2'
MODE_CONTINU='3'
SHOW_RESUME='4'
SHOW_DETAIL='5'
class summaryShow():
    def __init__(self, root, txSignal,  txparam):
        self.root=root
        self.txSignal=txSignal
        self.txparam=txparam
        self. select=IntVar()
        self.text_PPM={}
        self.text_servo={}
        self.can=None  # None is a switch !=None means that the show windows exists
        self.servo=None
        self.message=StringVar()
        
    def action_edit(self, event=None):
        ch=int(self.select.get())
        servo = self.txparam.linkage.get(ch, None)
        if servo !=None  :  # exists
            if servo.name=='rod':                d = servo_rod(self.root,servo)
            if servo.name=='pushrod':                d = servo_flex(self.root, servo )
        else:  # create new
            pass
        self.paint ()
        self.root.mainloop()
    def action_rod(self, event=None):
        ch=int(self.select.get())
        servo = self.txparam.linkage.get(ch, None)
        if servo == None  :
            self.txparam.linkage[ch]=Calc.servo_rod(ch)
            d = servo_rod(self.root,self.txparam.linkage[ch] ) 
        else: 
            pass
        self.paint ()
        self.root.mainloop()               
    def action_flexrod(self, event=None):
        ch=int(self.select.get())
        servo = self.txparam.linkage.get(ch, None)
        if servo == None  :
            self.txparam.linkage[ch]=Calc.servo_flexrod(ch)
            d = servo_flexrod(self.root,self.txparam.linkage[ch] ) 
        else: 
            pass
        self.paint ()
        self.root.mainloop()    
    def action_del(self, event=None):
        ch=int(self.select.get())
        if self.txparam.linkage.get(ch, None)==None:
            return
       
        del self.txparam.linkage[ch]
        self.paint ()
        root.mainloop()    
    def action_close(self, event=None):
        # users close the show
        self.can=None
        self.showServo.destroy()
    def action_show(self, event=None):
        global continu
        ch=int(self.select.get())
        if ch ==0: 
            return
        if self.txparam.linkage.get(ch, None)==None:
            return
        if self.can ==None:
            continu=True
            self.showServo =Toplevel()
            self.showServo.title("Servo Channel "+str(ch))
            self.can = Canvas(self.showServo,bg="grey",height=200,width=600)
            self.can.pack()
            self.showServo.protocol("WM_DELETE_WINDOW", self.action_close)
        else:
            self.can=None
            self.showServo.destroy()
    
        
    def paint(self):
        # paints the fixed data - the continu variable signal is "repaint"
        master=self.root
        # ____________________________this is put on the toplevel root frame
        ch=1
        Label(master, text="Selected ").grid(row=0, column=1)
        Label(master, text="TX Signal    ").grid(row=0, column=2)
        Label(master, text="Servo descr           ").grid(row=0, column=3)
        Label(master, text="Control surface position          ").grid(row=0, column=4)
        while ch <12:
            Radiobutton(master, text=str(ch), variable=self.select, value=ch).grid(row=ch,  column=1)
            self.text_PPM[ch]=StringVar()
            Label(master, textvariable=self.text_PPM[ch], width=20).grid(row=ch, column=2)
            t=""
            if self.txparam.linkage.has_key(ch): # test for a servo description and print name 
                servo=self.txparam.linkage[ch]
                t=servo.descr
            Label(master, text=t).grid(row=ch, column=3)                  
            self.text_servo[ch]=StringVar()  
            Label(master, textvariable=self.text_servo[ch], width=20).grid(row=ch, column=4)  # servo position
                    
            ch+=1 #___________________________end loop
        # actions frame
        box = LabelFrame(master, text="Selected Servo")
        Button(box, text="Edit",command=self.action_edit, default=ACTIVE).pack(side=LEFT, padx=5, pady=5)
        Button(box, text="New Rod ", command=self.action_rod, default=ACTIVE).pack(side=LEFT, padx=5, pady=5)
        Button(box, text="New Flex", command=self.action_flexrod, default=ACTIVE).pack(side=LEFT, padx=5, pady=5)
        Button(box, text="Del", command=self.action_del, default=ACTIVE).pack(side=LEFT, padx=5, pady=5)
        Button(box, text="Show", command=self.action_show, default=ACTIVE).pack(side=LEFT, padx=5, pady=5)
        box.grid(row=13, column=1, columnspan=4)    
        Label(master, textvariable=self.message, fg='red').grid(row=14, column=1, columnspan=4)    
        
        self.paintVar()
    def paintVar(self):
        master=self.root
        # ____________________________this is put on the toplevel root frame
        ch=1
        while ch <12:
            signal=-100
            for item in self.txSignal.ppm:
                if item[0]==ch:
                    self.text_PPM[ch].set("%5.3f    %5.1f"%(item[2]*1000, item[3])) # signal TX msec and % on this channel
                    signal=item[2]
            if self.txparam.linkage.has_key(ch): # test for a servo description and print name 
                servo=self.txparam.linkage[ch]
                if signal > -2:   # if servo  signal
                    servo.getCtrl(signal)                    
                    self.text_servo[ch].set( " %3.1f°   %3.0f" %(servo.ctrla/Calc.DEGR , servo.ctrld) )
                    
            ch+=1 #___________________________end loop
    def draw(self):
        if self.can !=None:
            ch=int(self.select.get())
            servo = self.txparam.linkage.get(ch, None)
            servo.init()
            for item in self.txSignal.ppm:
                if item[0]==ch:
                    servo.getCtrl(item[2])
                    servo.getCan(self.can, "red")

class Dialog(Toplevel):
    #inspiration # http://effbot.org/tkinterbook/tkinter-dialog-windows.htm
    # dialogue modal
    #cette classe est héritée par chacun des dialogues de l'application
    def __init__(self, parent, data,title = None):
        Toplevel.__init__(self, parent)
        self.transient(parent)
        self.data=data
        if title:
            self.title(title)
        self.parent = parent
        self.result = None
        body = Frame(self)
        self.initial_focus = self.body(body,data)
        body.pack(padx=5, pady=5)
        self.buttonbox()
        self.grab_set()#makes sure that no mouse or keyboard events are sent to the wrong window
        if not self.initial_focus:
            self.initial_focus = self
        self.protocol("WM_DELETE_WINDOW", self.cancel)
        self.geometry("+%d+%d" % (parent.winfo_rootx()+50,                               parent.winfo_rooty()+50))
        self.initial_focus.focus_set()
        self.wait_window(self)

    #
    # construction hooks

    def body(self, master,data):
        # create dialog body.  return widget that should have
        # initial focus.  this method should be overridden

        pass

    def buttonbox(self):
        # add standard button box. override if you don't want the
        # standard buttons
        
        box = Frame(self)
        w = Button(box, text="OK", width=10, command=self.ok, default=ACTIVE)
        w.pack(side=LEFT, padx=5, pady=5)
        w = Button(box, text="Cancel", width=10, command=self.cancel)
        w.pack(side=LEFT, padx=5, pady=5)
        self.bind("&lt;Return>", self.ok)
        self.bind("&lt;Escape>", self.cancel)
        box.pack()
       
        # standard button semantics

    def ok(self, event=None):

        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            
            return

        self.withdraw()
        self.update_idletasks()

        self.apply()

        self.cancel()

    def cancel(self, event=None):

        # put focus back to the parent window
        self.parent.focus_set()
        self.destroy()

        #
        # command hooks

    def validate(self,data):

        return 1 # override

    def apply(self,data):

        pass # override
class TX(Dialog):
    def body(self, master, txparam):
        self.txparam=txparam
        def getTXnormalPulse(x):
            txparam.normalPulse=float(x)/1000
        def getTXmaxPulse(x):
            txparam.maxPulse=float(x)/1000
        def getTXtrigger(x):
            txparam.triggerlevel=float(x)
        self.TXneutral = Scale(master, from_=1.25, to=1.65,  resolution=0.01, label="Neutral 0%", command=getTXnormalPulse)
        self.TXneutral .set(txparam.normalPulse*1000)
        self.TXneutral.pack(side=LEFT)
        self.TXwidth = Scale(master, from_=-0.40, to=0.60, resolution=0.01,  label="Width 100%", command=getTXmaxPulse)
        self.TXwidth.set(txparam.maxPulse*1000)
        self.TXwidth.pack(side=LEFT)
        self.TXtrigger = Scale(master, from_=-.99, to=.99, resolution=0.01,  label="Trigger level", command=getTXtrigger)
        self.TXtrigger.set(txparam.triggerlevel)
        self.TXtrigger.pack(side=LEFT)
        
        self.PCMV=IntVar(value=txparam.PCM)
        self.PCM=Checkbutton(master, text="PCM ",offvalue=0, onvalue=1, variable=self.PCMV).pack(side=LEFT)
        self.PCMchV=IntVar(value=txparam.PCMch)
        self.PCMch = Entry(master,textvariable= self.PCMchV, width=3).pack(side=LEFT)
        return self.TXtrigger

    def validate(self):
        try:
            PCMch=int(self.PCMchV.get())
        except:
            answer=tkMessageBox.showerror("Error" ,"one number is not correct")
            print sys.exc_info()
            return 0
        else:
            self.txparam.PCMch=PCMch
        return 1
    def apply(self):
        self.txparam.PCM=int(self.PCMV.get())

class servo(Dialog):
   # basis GUI class for a control: the servo and the control surface
    # to be herited by a servo_xxx class which provides the details of the linkage between servo and control surface
 
    def bodyLinkage(self, master, servo): 
        #this method should be overridden for each linkage
        #shows the parameters of a linkage
        return 0 #LabelFrame(master, text="Linkage parameters") 
    def imageName(self):
        #this method should be overridden for each linkage
        return 'xxx.gif'

    def body(self, master, servo):
        t= "Servo channel %2.0i  %s"%(servo.channel, servo.descr)
        self.title(t)
        self.servo=servo
        self.master=master
        self.servotemp=copy.deepcopy(servo) # copy for temporary update
        # all the parameters of a servo, often standard
       #_________frame with a schema__________________________________
        photo=PhotoImage(file=self.imageName())
        label = Label(master,image=photo)
        label.image = photo # keep a reference!
        label.grid(row=0, columnspan=2) #position of the frame with the picture  within the global frame  
        #__________frame servoparam ____________________________
        servoparam= LabelFrame(master, text="Servo parameters")
        w=7
        r=0
        Label(servoparam, text="Description:").grid(row=r)
        self.descrV= StringVar(value=servo.descr)
        self.descr = Entry(servoparam,textvariable= self.descrV, width=w)
        self.descr.grid(row=r, column=1)
        r+=1
        Label(servoparam, text="Normal pulse msec:").grid(row=r)
        self.normalPulseV= StringVar(value=servo.normalPulse*1000)
        self.normalPulse = Entry(servoparam,textvariable= self.normalPulseV, width=w)
        self.normalPulse.grid(row=r, column=1)
        r+=1
        Label(servoparam, text="max deviation msec").grid(row=r)
        self.maxPulseV= StringVar(value=servo.maxPulse*1000)
        self.maxPulse=Entry(servoparam,textvariable= self.maxPulseV, width=w)
        self.maxPulse.grid(row=r, column=1)
        r+=1
        Label(servoparam, text="max deflection °").grid(row=r)
        self.servodevV= StringVar(value=servo.servodev/Calc.DEGR)
        self.servodev=Entry(servoparam,textvariable= self.servodevV, width=w)
        self.servodev.grid(row=r, column=1)   
        r+=1
        self.servoDirectionV=IntVar(value=servo.servoDirection)
        Checkbutton(servoparam, text="Servo clockwise at signal +100%", offvalue=-1, onvalue=1, variable=self.servoDirectionV).grid( row=r, columnspan=2)
        r+=1
        self.pV=IntVar(value=servo.p)
        Checkbutton(servoparam, text="Servo arm is up",offvalue=-1, onvalue=1, variable=self.pV).grid( row=r, columnspan=2)
        r+=1
        Label(servoparam, text="rp= servo arm radius mm:").grid(row=r)
        self.rpV= StringVar(value=servo.rp)
        self.rp= Entry(servoparam,textvariable= self.rpV, width=w)
        self.rp.grid(row=r, column=1) 
        r+=1
        Label(servoparam, text="dp= servo arm shift mm:").grid(row=r)
        self.dpV= StringVar(value=servo.dp)
        self.dp= Entry(servoparam,textvariable= self.dpV, width=w)
        self.dp.grid(row=r, column=1) 
        
        servoparam.grid(row=1, rowspan=2, column=0, sticky=W+E)#position of the frame servoparam  within the global frame
        
        
        
        #frame with the parameters of the linkage
        links=self.bodyLinkage(master, servo)
        links.grid(row=1, column=1)
        
        #_____________frame horn___________________________________
        r=0
        horn= LabelFrame(master, text="Horn parameters")
        Label(horn, text="rg= horn radius mm:").grid(row=r)
        self.rgV= StringVar(value=servo.rg)
        self.rg= Entry(horn,textvariable= self.rgV, width=w)
        self.rg.grid(row=r, column=1)       
        r+=1      
        Label(horn, text="dg= horn shift mm:").grid(row=r)
        self.dgV= StringVar(value=servo.dg)
        self.dg= Entry(horn,textvariable= self.dgV, width=w)
        self.dg.grid(row=r, column=1)         
        r+=1          
        Label(horn, text="C= chord mm:").grid(row=r)
        self.ctrl_cV= StringVar(value=servo.ctrl_c)
        self.ctrl_c= Entry(horn,textvariable= self.ctrl_cV, width=w)
        self.ctrl_c.grid(row=r, column=1)
        r+=1      
        Label(horn, text="A= angle in degrees").grid(row=r)
        self.ctrl_aV= StringVar(value=servo.ctrl_a/Calc.DEGR)
        self.ctrl_a= Entry(horn,textvariable= self.ctrl_aV, width=w)
        self.ctrl_a.grid(row=r, column=1)     
        self.gV=IntVar(value=servo.g)
        r+=1      
        Checkbutton(horn, text="Horn arm is up", offvalue=-1, onvalue=1,variable=self.gV).grid( row=r, columnspan=1)
        horn.grid(row=2, column=1, sticky=W+E) #position of the frame horn within the global frame
        
        #show graphic  and slider
        canframe= LabelFrame(master, text="Show cinematic")
        self.canctrl = Canvas(canframe,bg="grey",height=150,width=400)
        self.canctrl.pack(side=LEFT)
        colour="black"
        self.servo.init()
        signal=servo.normalPulse
        self.servo.getCtrl(signal)
        self.servo.getCan(self.canctrl, colour)
        def getSignal(x):  
            #answer to a movement of the slider x=new value
            signal=servo.normalPulse+float(x)*servo.maxPulse
            try:
                self.servo.getCtrl(signal)
            except:
                self.canctrl.create_text(10, 10, text="Linkage is not possible", anchor=NW,width=50, fill='red')
            else:
                self.servo.getCan(self.canctrl, colour)
                #self.servo.getCanLinkage(self.canctrl, colour)
                
            
            
        # slider
        TXsignal = Scale(canframe, from_=-1, to=+1,  resolution=0.1, label="Signal %", command=getSignal)
        TXsignal.pack(side=LEFT)
        canframe.grid(row=3, rowspan=2, column=0, sticky=W+E)#
        return self.rg
    def buttonbox(self):
        box = Frame(self)
        w = Button(box, text="OK", width=10, command=self.ok, default=ACTIVE)
        w.pack(side=LEFT, padx=5, pady=5)
        w = Button(box, text="Update", width=10, command=self.show)
        w.pack(side=LEFT, padx=5, pady=5)
        w = Button(box, text="Plot", width=10, command=self.plotCtrl)
        w.pack(side=LEFT, padx=5, pady=5)
        self.bind("&lt;Return>", self.show)
        box.pack()
    

    def show(self, event=None):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.servo.init()
        signal=self.servo.normalPulse
        try:
            self.servo.getCtrl(signal)
        except:
            self.canctrl.create_text(10, 10, text="Linkage is not possible", anchor=NW,width=50, colour='red')
        else:
            self.servo.getCan(self.canctrl, "black")
 
    def validateLinkage(self):
        # to be overridden for each linkage
        return 0  #returns 0 if error, 1 if Ok
    def validate(self):
        try:
            normalPulse=float(self.normalPulseV.get())/1000.0
            maxPulse=float(self.maxPulseV.get())/1000.0
            servodev=float(self.servodevV.get()) *Calc.DEGR
            rp=  float(self.rpV.get())
            dp=  float(self.dpV.get())
            rg=  float(self.rgV.get())
            dg=  float(self.dgV.get())
            ctrl_c=float(self.ctrl_cV.get())
            ctrl_a=float(self.ctrl_aV.get())*Calc.DEGR
            
        except:
            answer=tkMessageBox.showerror("Error" ,"one number is not correct")
            print sys.exc_info()
            return 0
        else:
            self.servo.descr=self.descrV.get()
            self.servo.normalPulse=normalPulse
            self.servo.maxPulse=maxPulse
            self.servo.servodev=servodev
            self.servo.servoDirection=int(self.servoDirectionV.get())
            self.servo.p=self.pV.get()
            self.servo.rp=rp
            self.servo.dp=dp
            self.servo.rg=rg
            self.servo.dg=dg
            self.servo.ctrl_c=ctrl_c
            self.servo.ctrl_a=ctrl_a
            self.servo.g=self.gV.get()
        return self.validateLinkage()
    def apply(self):
        self.servo.init()
    def plotCtrl(self, event=None):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        #graph angle control surface / signal
        dx =.05
        data = []
        x=-1
        self.servo.init()
        message=""
        while True:
           #First, we create the line/curve that we wish to plot:
            try:
                self.servo.getCtrl(self.servo.normalPulse+x*self.servo.maxPulse)
            except:
                    message="ERROR :  not always possible"""
            else:    
                data.append((x*100,  self.servo.ctrla/Calc.DEGR))
            if x>1.0:
               break
            x=x+dx
        #Gui.simpleGraph(root, data, "Courant(A)  / vitesse de vol (m/sec)", projet.cellule.descr +"  / Courant")
        base=Toplevel()
        base.title("Control surface angle  / servo signal")
        linea  = plot.GraphLine(data, color='gray', smooth=0)
        #we create the GraphObject which does the necessary scaling:
        graphObject = plot.GraphObjects([  linea])
        #create the graph widget and associate the GraphObject with it:
        graph  = plot.GraphBase(base, 500, 400, relief=SUNKEN, border=2)
        graph.pack(side=TOP, fill=BOTH, expand=YES)
        graph.draw(graphObject, 'automatic', 'automatic')
        Label(base, text=message, fg="red").pack()
        
class servo_rod(servo):
    def imageName(self):
        return 'Servo_rod.gif'
    def bodyLinkage(self, master, servo):
        # all the parameters of a linkage
        link= LabelFrame(master, text="Linkage parameters")
        Label(link, text="DH= Hor. distance mm:").grid(row=0)
        self.dhV= StringVar(value=servo.dh)
        self.dh = Entry(link,textvariable= self.dhV, width=w)
        self.dh.grid(row=0, column=1)
        Label(link, text="DV= vert. distance mm:").grid(row=1)
        self.dvV= StringVar(value=servo.dv)
        self.dv = Entry(link,textvariable= self.dvV, width=w)
        self.dv.grid(row=1, column=1)     
        return link
    def validateLinkage(self):
        try:
            dh=  float(self.dhV.get())
            dv=  float(self.dvV.get())
        except:
            answer=tkMessageBox.showerror("Error" ,"one number is not correct")
            print sys.exc_info()
            return 0
        else:
            self.servo.dh=dh
            self.servo.dv=dv
            return 1
class servo_flexrod(servo):
    def imageName(self):
        return 'Servo_flexrod.gif'
    def bodyLinkage(self, master, servo):
        # all the parameters of a linkage
        r=0
        link= LabelFrame(master, text="Linkage parameters")
        Label(link, text="DHp= Hor. distance mm:").grid(row=r)
        self.dhpV= StringVar(value=servo.dhp)
        self.dhp = Entry(link,textvariable= self.dhpV, width=w)
        self.dhp.grid(row=r, column=1)
        r=1
        Label(link, text="DVp= vert. distance mm:").grid(row=r)
        self.dvpV= StringVar(value=servo.dvp)
        self.dvp = Entry(link,textvariable= self.dvpV, width=w)
        self.dvp.grid(row=r, column=1)     
        r=2
        Label(link, text="DHg= Hor. distance mm:").grid(row=r)
        self.dhgV= StringVar(value=servo.dhg)
        self.dhg = Entry(link,textvariable= self.dhgV, width=w)
        self.dhg.grid(row=r, column=1)
        r=3
        Label(link, text="DVg= vert. distance mm:").grid(row=r)
        self.dvgV= StringVar(value=servo.dvg)
        self.dvg = Entry(link,textvariable= self.dvgV, width=w)
        self.dvg.grid(row=r, column=1)     
        return link
    def validateLinkage(self):
        try:
            dhp=  float(self.dhpV.get())
            dvp=  float(self.dvpV.get())
            dhg=  float(self.dhgV.get())
            dvg=  float(self.dvgV.get())
        except:
            answer=tkMessageBox.showerror("Error" ,"one number is not correct")
            print sys.exc_info()
            return 0
        else:
            self.servo.dhp=dhp
            self.servo.dvp=dvp
            self.servo.dhg=dhg
            self.servo.dvg=dvg
            return 1

def TXtest(txSignal):
    # show one oscillo trace of the TX signal
   base=Toplevel()
   base.title("Oscillo trace of TX")
   print  txSignal.snd.info()
   can = Canvas(base,bg="grey",height=300,width=800)
   can.pack()
   createWaveform(can, 0, 150, sound=txSignal.snd,  pixelspersecond=20000, zerolevel=False)
    
#if __name__ == '__main__':
#    import  tkFileDialog, pickle
#    root=Tk()
#    initializeSnack(root)
#    txparam= Calc.TX()  # all the parameters , transmitter, servos, linkages ....
#    txSignal=Calc.TXsignal(txparam) # signal processing
#    modelfilename=tkFileDialog.askopenfilename(initialdir="Models",defaultextension=".srv")
#    modelfile =open(modelfilename, "r")
#    txparam=pickle.load(modelfile)    
#    sum=summaryShow(root, txSignal,  txparam)
#    sum.paint()
#    root.mainloop()
